/*
 * Copyright (c) 2005, Joshua Wright <jwright@hasborg.com>
 *
 * $Id: bluecrypt.h,v 1.2 2005/09/07 22:50:17 jwright Exp $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation. See COPYING for more
 * details.
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

/* Core Bluetooth authentication/hashing functions */
int e21(uint8_t *in_rand, uint8_t *in_bdaddr, uint8_t *out_link_key);
int e22(uint8_t *in_pin, uint8_t *in_rand, int pinlenprime, uint8_t *out_k);
int e1(uint8_t *in_kab, uint8_t *in_rand, uint8_t *in_bdaddr,
		uint8_t *out_sres, uint8_t *out_aco);

/* Wrappers for Bluetooth functions to produce desired outputs */
int gen_kab(uint8_t *in_bdaddr_a, uint8_t *in_bdaddr_b, uint8_t *in_lkrand_a,
		uint8_t *in_lkrand_b, uint8_t *out_kab);
int gen_lkrand(uint8_t *in_lkcombrand, uint8_t *in_kinit, uint8_t *out_lkrand);
int gen_kinit(uint8_t in_pinlen, uint8_t *in_pin, uint8_t *in_bdaddr,
		uint8_t *in_rand, uint8_t *out_kinit);
int gen_sresaco(uint8_t *in_kab, uint8_t *in_aurand, uint8_t *in_bdaddr,
		uint8_t *out_sres, uint8_t *out_aco);
int gen_kmaster(uint8_t *in_key, uint8_t *in_rand, uint8_t *out_k);

