/*
 * Copyright (c) 2005, Joshua Wright <jwright@hasborg.com>
 *
 * $Id: utils.c,v 1.4 2005/09/07 22:50:17 jwright Exp $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation. See COPYING for more
 * details.
 *
 * This code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include "utils.h"

/* For the data block of length len, convert values to ASCII and return
   pointer to global hexstr[] array. */
char *hex2str(uint8_t *data, int len)
{
	int i;
	char *str = hexstr;
	memset(hexstr, 0, sizeof(hexstr));

	for (i = 0; i < len; i++) {
		if (strlen(hexstr) >= sizeof(hexstr)) {
			return str;
		}
		snprintf(str + strlen(hexstr), 3, "%02x", data[i]);
	}
	return str;
}


/*
 * converts a string to a mac address...
 * returns 1 on success, -1 on failure...
 * failure indicates poorly formed input...
 */
int str2hex (char *string, uint8_t *hexstr, int len)
{
    char                        *ptr, *next;
    unsigned long       val;
    int                         i;

    ptr = next = string;
    for(i=0;i < len;i++) {
        if((val = strtoul(next, &ptr, 16)) > 255) {
            errno = EINVAL;
            return(-1);
        }
        hexstr[i] = (unsigned int)val;
        if((next == ptr) && (i != len - 1)) {
            errno = EINVAL;
            return(-1);
        }
        next = ptr + 1;
    }

    return(1);
}
